#!/usr/bin/perl -w

use strict;

my $debug=1;
my $ssh='/usr/bin/ssh';
my $ping='/bin/ping';

my $terminal = shift;

die "No terminal specified\n" unless $terminal;

poweroff ($terminal);

exit 1;

#
# subroutines
#

sub poweroff {
	my ($terminal) = @_;
	print "$terminal\n" if $debug;
	system "$ping $terminal -c 1 -W 1 >/dev/null && ssh -x -oConnectTimeout=1 -oStrictHostKeyChecking=no -oNumberOfPasswordPrompts=0 -f $terminal 'sudo /usr/local/sbin/terminalpoweroff'";
}
