#!/usr/bin/perl -w

use strict;

my $debug=1;
my $ssh='/usr/bin/ssh';
my $ping='/bin/ping';

my $arg = shift;

$arg = 'both' unless $arg;
unless ($arg =~ /^(dpo|eietl|both)$/) {
	die "$0 [dpo|eietl|both]\n";
}


if ($arg =~ /^dpo|both$/) {
	for (my $i = 1; $i < 10; $i++) {
		for (my $j = 1; $j < 17; $j++) {
			my $terminal = $j;
			$terminal = '0'.$j if $j < 10;
			$terminal = 'tw'.$i.$terminal;
			poweroff ($terminal);
		}
	}
}

if ($arg =~ /^eietl|both$/) {
	for (my $i = 101; $i < 133; $i++) {
        	my $terminal = 'ew'.$i;
        	poweroff ($terminal);
	}
	for (my $i = 201; $i < 233; $i++) {
        	my $terminal = 'ew'.$i;
        	poweroff ($terminal);
	}
	for (my $i = 301; $i < 333; $i++) {
        	my $terminal = 'ew'.$i;
        	poweroff ($terminal);
	}
}

exit 1;

#
# subroutines
#

sub poweroff {
	my ($terminal) = @_;
	return unless gethostbyname("$terminal.eng.cam.ac.uk");
	print "$terminal\n" if $debug;
	system "$ping $terminal -c 1 -W 1 >/dev/null && $ssh -x -oConnectTimeout=1 -oStrictHostKeyChecking=no -oNumberOfPasswordPrompts=0 -f $terminal 'sudo /usr/local/sbin/terminalpoweroff'";
}
